' This is file test.bi
' (C) by ...

' FB comments get into the output, but

#Define FANN_USE_DLL

#Inclib "fannfloat"
'#Inclib "fannfixed"
'#Inclib "fanndouble"

#Ifndef FANN_NO_DLL
#define FANN_USE_DLL
#endif '	/* FANN_USE_LIB */
#If Defined(_MSC_VER) and (defined(FANN_USE_DLL) or defined(FANN_DLL_EXPORTS))
#ifdef FANN_DLL_EXPORTS
#define FANN_EXTERNAL __declspec(dllexport)
#else	'						/*  */
#define FANN_EXTERNAL __declspec(dllimport)
#EndIf '	/* FANN_DLL_EXPORTS*/
#define FANN_API __stdcall
#else	'						/*  */
#define FANN_EXTERNAL
#define FANN_API
#endif	


' /* Section: FANN Error Handling' '    Errors from the fann library are usually reported on stderr. '    It is however possible to redirect these error messages to a file, '    or completely ignore them by the <fann_set_error_log> function.'    '    It is also possible to inspect the last error message by using the'    <fann_get_errno> and <fann_get_errstr> functions.'  */' ' /* Enum: fann_errno_enum' 	Used to define error events on <struct fann> and <struct fann_train_data>. ' ' 	See also:' 		<fann_get_errno>, <fann_reset_errno>, <fann_get_errstr>' ' 	FANN_E_NO_ERROR - No error ' 	FANN_E_CANT_OPEN_CONFIG_R - Unable to open configuration file for reading ' 	FANN_E_CANT_OPEN_CONFIG_W - Unable to open configuration file for writing' 	FANN_E_WRONG_CONFIG_VERSION - Wrong version of configuration file ' 	FANN_E_CANT_READ_CONFIG - Error reading info from configuration file' 	FANN_E_CANT_READ_NEURON - Error reading neuron info from configuration file' 	FANN_E_CANT_READ_CONNECTIONS - Error reading connections from configuration file' 	FANN_E_WRONG_NUM_CONNECTIONS - Number of connections not equal to the number expected' 	FANN_E_CANT_OPEN_TD_W - Unable to open train data file for writing' 	FANN_E_CANT_OPEN_TD_R - Unable to open train data file for reading' 	FANN_E_CANT_READ_TD - Error reading training data from file' 	FANN_E_CANT_ALLOCATE_MEM - Unable to allocate memory' 	FANN_E_CANT_TRAIN_ACTIVATION - Unable to train with the selected activation function' 	FANN_E_CANT_USE_ACTIVATION - Unable to use the selected activation function' 	FANN_E_TRAIN_DATA_MISMATCH - Irreconcilable differences between two <struct fann_train_data> structures' 	FANN_E_CANT_USE_TRAIN_ALG - Unable to use the selected training algorithm' 	FANN_E_TRAIN_DATA_SUBSET - Trying to take subset which is not within the training set' 	FANN_E_INDEX_OUT_OF_BOUND - Index is out of bound' 	FANN_E_SCALE_NOT_PRESENT - Scaling parameters not present'     FANN_E_INPUT_NO_MATCH - The number of input neurons in the ann and data don't match'     FANN_E_OUTPUT_NO_MATCH - The number of output neurons in the ann and data don't match' */' enum fann_errno_enum' {' 	FANN_E_NO_ERROR = 0,' 	FANN_E_CANT_OPEN_CONFIG_R,' 	FANN_E_CANT_OPEN_CONFIG_W,' 	FANN_E_WRONG_CONFIG_VERSION,' 	FANN_E_CANT_READ_CONFIG,' 	FANN_E_CANT_READ_NEURON,' 	FANN_E_CANT_READ_CONNECTIONS,' 	FANN_E_WRONG_NUM_CONNECTIONS,' 	FANN_E_CANT_OPEN_TD_W,' 	FANN_E_CANT_OPEN_TD_R,' 	FANN_E_CANT_READ_TD,' 	FANN_E_CANT_ALLOCATE_MEM,' 	FANN_E_CANT_TRAIN_ACTIVATION,' 	FANN_E_CANT_USE_ACTIVATION,' 	FANN_E_TRAIN_DATA_MISMATCH,' 	FANN_E_CANT_USE_TRAIN_ALG,' 	FANN_E_TRAIN_DATA_SUBSET,' 	FANN_E_INDEX_OUT_OF_BOUND,' 	FANN_E_SCALE_NOT_PRESENT,' 	FANN_E_INPUT_NO_MATCH,' 	FANN_E_OUTPUT_NO_MATCH' };
enuM fann_errno_enum
  FANN_E_NO_ERROR = 0
  FANN_E_CANT_OPEN_CONFIG_R
  FANN_E_CANT_OPEN_CONFIG_W
  FANN_E_WRONG_CONFIG_VERSION
  FANN_E_CANT_READ_CONFIG
  FANN_E_CANT_READ_NEURON
  FANN_E_CANT_READ_CONNECTIONS
  FANN_E_WRONG_NUM_CONNECTIONS
  FANN_E_CANT_OPEN_TD_W
  FANN_E_CANT_OPEN_TD_R
  FANN_E_CANT_READ_TD
  FANN_E_CANT_ALLOCATE_MEM
  FANN_E_CANT_TRAIN_ACTIVATION
  FANN_E_CANT_USE_ACTIVATION
  FANN_E_TRAIN_DATA_MISMATCH
  FANN_E_CANT_USE_TRAIN_ALG
  FANN_E_TRAIN_DATA_SUBSET
  FANN_E_INDEX_OUT_OF_BOUND
  FANN_E_SCALE_NOT_PRESENT
  FANN_E_INPUT_NO_MATCH
  FANN_E_OUTPUT_NO_MATCH
eNd enuM
' enum fann_nettype_enum' {'     FANN_NETTYPE_LAYER = 0, /* Each layer only has connections to the next layer */'     FANN_NETTYPE_SHORTCUT /* Each layer has connections to all following layers */' };
enuM fann_nettype_enum
  FANN_NETTYPE_LAYER = 0
  FANN_NETTYPE_SHORTCUT
eNd enuM

' /* Function: fann_create_standard' 	' 	Creates a standard fully connected backpropagation neural network.' ' 	There will be a bias neuron in each layer (except the output layer),' 	and this bias neuron will be connected to all neurons in the next layer.' 	When running the network, the bias nodes always emits 1.' 	' 	To destroy a <struct fann> use the <fann_destroy> function.' ' 	Parameters:' 		num_layers - The total number of layers including the input and the output layer.' 		... - Integer values determining the number of neurons in each layer starting with the ' 			input layer and ending with the output layer.' 			' 	Returns:' 		A pointer to the newly created <struct fann>.' 			' 	Example:' 		> // Creating an ANN with 2 input neurons, 1 output neuron, ' 		> // and two hidden neurons with 8 and 9 neurons' 		> struct fann *ann = fann_create_standard(4, 2, 8, 9, 1);' 		' 	See also:' 		<fann_create_standard_array>, <fann_create_sparse>, <fann_create_shortcut>		' 		' 	This function appears in FANN >= 2.0.0.' */ ' FANN_EXTERNAL struct fann *FANN_API fann_create_standard(unsigned int num_layers, ...);
#Define fann any
#Define fann_train_data Any
#define fann_connection Any
#Define fann_type float


'Extern "C" 
'FANN_EXTERNAL struct fann *FANN_API fann_create_from_file(
'   	const 	char 	*	configuration_file
')
Declare FUNCTION fann_create_from_file StdCall Alias "fann_create_from_file" ( _
  ByVal fic AS zString Ptr) AS FANN_EXTERNAL fann FANN_API PTR


Declare FUNCTION fann_create_standard StdCall Alias "fann_create_standard" ( _
  BYVAL num_layers AS UInteger) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_create_standard_array'    Just like <fann_create_standard>, but with an array of layer sizes'    instead of individual parameters.' ' 	Example:' 		> // Creating an ANN with 2 input neurons, 1 output neuron, ' 		> // and two hidden neurons with 8 and 9 neurons' 		> unsigned int layers[4] = {2, 8, 9, 1};' 		> struct fann *ann = fann_create_standard_array(4, layers);' ' 	See also:' 		<fann_create_standard>, <fann_create_sparse>, <fann_create_shortcut>' ' 	This function appears in FANN >= 2.0.0.' */ ' FANN_EXTERNAL struct fann *FANN_API fann_create_standard_array(unsigned int num_layers,' 													           const unsigned int *layers);
DECLARE FUNCTION fann_create_standard_array StdCall Alias "fann_create_standard_array" ( _
  BYVAL num_layers AS UINTEGER, _
  BYVAL layers AS CONST UINTEGER PTR) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_create_sparse' ' 	Creates a standard backpropagation neural network, which is not fully connected.' ' 	Parameters:' 		connection_rate - The connection rate controls how many connections there will be in the'    			network. If the connection rate is set to 1, the network will be fully'    			connected, but if it is set to 0.5 only half of the connections will be set.' 			A connection rate of 1 will yield the same result as <fann_create_standard>' 		num_layers - The total number of layers including the input and the output layer.' 		... - Integer values determining the number of neurons in each layer starting with the ' 			input layer and ending with the output layer.' 			' 	Returns:' 		A pointer to the newly created <struct fann>.' ' 	See also:' 		<fann_create_sparse_array>, <fann_create_standard>, <fann_create_shortcut>' ' 	This function appears in FANN >= 2.0.0.' */' FANN_EXTERNAL struct fann *FANN_API fann_create_sparse(float connection_rate, ' 	                                                   unsigned int num_layers, ...);
DECLARE FUNCTION fann_create_sparse StdCall Alias "fann_create_sparse" ( _
  BYVAL connection_rate AS SINGLE, _
  BYVAL num_layers AS UInteger) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_create_sparse_array'    Just like <fann_create_sparse>, but with an array of layer sizes'    instead of individual parameters.' ' 	See <fann_create_standard_array> for a description of the parameters.' ' 	See also:' 		<fann_create_sparse>, <fann_create_standard>, <fann_create_shortcut>' ' 	This function appears in FANN >= 2.0.0.' */' FANN_EXTERNAL struct fann *FANN_API fann_create_sparse_array(float connection_rate, ' 	                                                         unsigned int num_layers, ' 															 const unsigned int *layers);
DECLARE FUNCTION fann_create_sparse_array StdCall alias "fann_create_sparse_array" ( _
  BYVAL connection_rate AS SINGLE, _
  BYVAL num_layers AS UINTEGER, _
  BYVAL layers AS CONST UINTEGER PTR) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_create_shortcut' ' 	Creates a standard backpropagation neural network, which is not fully connected and which' 	also has shortcut connections.' '  	Shortcut connections are connections that skip layers. A fully connected network with shortcut ' 	connections, is a network where all neurons are connected to all neurons in later layers. ' 	Including direct connections from the input layer to the output layer.' ' 	See <fann_create_standard> for a description of the parameters.' ' 	See also:' 		<fann_create_shortcut_array>, <fann_create_standard>, <fann_create_sparse>, ' ' 	This function appears in FANN >= 2.0.0.' */ ' FANN_EXTERNAL struct fann *FANN_API fann_create_shortcut(unsigned int num_layers, ...);
DECLARE FUNCTION fann_create_shortcut StdCall( _
  BYVAL num_layers AS UINTEGER) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_create_shortcut_array'    Just like <fann_create_shortcut>, but with an array of layer sizes'    instead of individual parameters.' ' 	See <fann_create_standard_array> for a description of the parameters.' ' 	See also:' 		<fann_create_shortcut>, <fann_create_standard>, <fann_create_sparse>' ' 	This function appears in FANN >= 2.0.0.' */' FANN_EXTERNAL struct fann *FANN_API fann_create_shortcut_array(unsigned int num_layers,' 															   const unsigned int *layers);
DECLARE FUNCTION fann_create_shortcut_array StdCall( _
  BYVAL num_layers AS UINTEGER, _
  BYVAL layers AS CONST UINTEGER PTR) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_destroy'    Destroys the entire network and properly freeing all the associated memmory.' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL void FANN_API fann_destroy(struct fann *ann);
DECLARE Sub fann_destroy stdcall Alias "fann_destroy" ( _
  BYVAL ann AS fann PTR) 'FANN_EXTERNAL Any FANN_API Ptr
  'BYVAL ann AS fann PTR) AS FANN_EXTERNAL ANY FANN_API

' /* Function: fann_copy'    Creates a copy of a fann structure. '    '    Data in the user data <fann_set_user_data> is not copied, but the user data pointer is copied.' ' 	This function appears in FANN >= 2.2.0.' */ ' FANN_EXTERNAL struct fann * FANN_API fann_copy(struct fann *ann);
DECLARE FUNCTION fann_copy StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL fann FANN_API PTR

' /* Function: fann_run' 	Will run input through the neural network, returning an array of outputs, the number of which being ' 	equal to the number of neurons in the output layer.' ' 	See also:' 		<fann_test>' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL fann_type * FANN_API fann_run(struct fann *ann, fann_type * input);
DECLARE FUNCTION fann_run StdCall Alias "fann_run" ( _
  BYVAL ann AS fann PTR, _
  BYVAL input_TJF AS fann_type PTR) AS FANN_EXTERNAL fann_type FANN_API PTR

' /* Function: fann_randomize_weights' 	Give each connection a random weight between *min_weight* and *max_weight*'    ' 	From the beginning the weights are random between -0.1 and 0.1.' ' 	See also:' 		<fann_init_weights>' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL void FANN_API fann_randomize_weights(struct fann *ann, fann_type min_weight,' 												   fann_type max_weight);
DECLARE FUNCTION fann_randomize_weights StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL min_weight AS fann_type, _
  BYVAL max_weight AS fann_type) AS FANN_EXTERNAL ANY FANN_API Ptr
'  BYVAL max_weight AS fann_type) AS FANN_EXTERNAL ANY FANN_API

' /* Function: fann_init_weights'   	Initialize the weights using Widrow + Nguyen's algorithm.' 	'  	This function behaves similarly to fann_randomize_weights. It will use the algorithm developed ' 	by Derrick Nguyen and Bernard Widrow to set the weights in such a way ' 	as to speed up training. This technique is not always successful, and in some cases can be less ' 	efficient than a purely random initialization.' ' 	The algorithm requires access to the range of the input data (ie, largest and smallest input), ' 	and therefore accepts a second argument, data, which is the training data that will be used to ' 	train the network.' ' 	See also:' 		<fann_randomize_weights>, <fann_read_train_from_file>' ' 	This function appears in FANN >= 1.1.0.' */ ' FANN_EXTERNAL void FANN_API fann_init_weights(struct fann *ann, struct fann_train_data *train_data);
DECLARE FUNCTION fann_init_weights StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL train_data AS fann_train_data PTR) AS FANN_EXTERNAL ANY FANN_API Ptr
'  BYVAL train_data AS fann_train_data PTR) AS FANN_EXTERNAL ANY FANN_API

' /* Function: fann_print_connections' 	Will print the connections of the ann in a compact matrix, for easy viewing of the internals ' 	of the ann.' ' 	The output from fann_print_connections on a small (2 2 1) network trained on the xor problem' 	>Layer / Neuron 012345' 	>L   1 / N    3 BBa...' 	>L   1 / N    4 BBA...' 	>L   1 / N    5 ......' 	>L   2 / N    6 ...BBA' 	>L   2 / N    7 ......' 		  ' 	This network have five real neurons and two bias neurons. This gives a total of seven neurons ' 	named from 0 to 6. The connections between these neurons can be seen in the matrix. "." is a ' 	place where there is no connection, while a character tells how strong the connection is on a ' 	scale from a-z. The two real neurons in the hidden layer (neuron 3 and 4 in layer 1) has ' 	connection from the three neurons in the previous layer as is visible in the first two lines. ' 	The output neuron (6) has connections form the three neurons in the hidden layer 3 - 5 as is ' 	visible in the fourth line.' ' 	To simplify the matrix output neurons is not visible as neurons that connections can come from, ' 	and input and bias neurons are not visible as neurons that connections can go to.' ' 	This function appears in FANN >= 1.2.0.' */ ' FANN_EXTERNAL void FANN_API fann_print_connections(struct fann *ann);
DECLARE FUNCTION fann_print_connections StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL ANY FANN_API Ptr
'  BYVAL ann AS fann PTR) AS FANN_EXTERNAL ANY FANN_API

' /* Group: Parameters */' /* Function: fann_print_parameters' '   	Prints all of the parameters and options of the ANN ' ' 	This function appears in FANN >= 1.2.0.' */ ' FANN_EXTERNAL void FANN_API fann_print_parameters(struct fann *ann);
DECLARE FUNCTION fann_print_parameters StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL ANY FANN_API ptr
'  BYVAL ann AS fann PTR) AS FANN_EXTERNAL ANY FANN_API

' /* Function: fann_get_num_input' '    Get the number of input neurons.' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL unsigned int FANN_API fann_get_num_input(struct fann *ann);
DECLARE FUNCTION fann_get_num_input StdCall Alias "fann_get_num_input" ( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL UINTEGER FANN_API

' /* Function: fann_get_num_output' '    Get the number of output neurons.' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL unsigned int FANN_API fann_get_num_output(struct fann *ann);
DECLARE FUNCTION fann_get_num_output StdCall Alias "fann_get_num_output" ( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL UINTEGER FANN_API

' /* Function: fann_get_total_neurons' '    Get the total number of neurons in the entire network. This number does also include the ' 	bias neurons, so a 2-4-2 network has 2+4+2 +2(bias) = 10 neurons.' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL unsigned int FANN_API fann_get_total_neurons(struct fann *ann);
DECLARE FUNCTION fann_get_total_neurons StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL UINTEGER FANN_API

' /* Function: fann_get_total_connections' '    Get the total number of connections in the entire network.' ' 	This function appears in FANN >= 1.0.0.' */ ' FANN_EXTERNAL unsigned int FANN_API fann_get_total_connections(struct fann *ann);
DECLARE FUNCTION fann_get_total_connections StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL UINTEGER FANN_API

' /* Function: fann_get_network_type' '     Get the type of neural network it was created as.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' ' 	Returns:'         The neural network type from enum <fann_network_type_enum>' '     See Also:'         <fann_network_type_enum>' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL enum fann_nettype_enum FANN_API fann_get_network_type(struct fann *ann);
DECLARE FUNCTION fann_get_network_type StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL fann_nettype_enum FANN_API

' /* Function: fann_get_connection_rate' '     Get the connection rate used when the network was created' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' ' 	Returns:'         The connection rate' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL float FANN_API fann_get_connection_rate(struct fann *ann);
DECLARE FUNCTION fann_get_connection_rate StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL SINGLE FANN_API

' /* Function: fann_get_num_layers' '     Get the number of layers in the network' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' 			' 	Returns:' 		The number of layers in the neural network' 			' 	Example:' 		> // Obtain the number of layers in a neural network' 		> struct fann *ann = fann_create_standard(4, 2, 8, 9, 1);'         > unsigned int num_layers = fann_get_num_layers(ann);' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL unsigned int FANN_API fann_get_num_layers(struct fann *ann);
DECLARE FUNCTION fann_get_num_layers StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL UINTEGER FANN_API

' /*Function: fann_get_layer_array' '     Get the number of neurons in each layer in the network.' '     Bias is not included so the layers match the fann_create functions.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' '     The layers array must be preallocated to at least'     sizeof(unsigned int) * fann_num_layers() long.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void FANN_API fann_get_layer_array(struct fann *ann, unsigned int *layers);
DECLARE FUNCTION fann_get_layer_array StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL layers AS UINTEGER PTR) AS FANN_EXTERNAL ANY FANN_API Ptr 'noptr

' /* Function: fann_get_bias_array' '     Get the number of bias in each layer in the network.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' '     The bias array must be preallocated to at least'     sizeof(unsigned int) * fann_num_layers() long.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void FANN_API fann_get_bias_array(struct fann *ann, unsigned int *bias);
DECLARE FUNCTION fann_get_bias_array StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL bias AS UINTEGER PTR) AS FANN_EXTERNAL ANY FANN_API Ptr 'noptr

' /* Function: fann_get_connection_array' '     Get the connections in the network.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' '     The connections array must be preallocated to at least'     sizeof(struct fann_connection) * fann_get_total_connections() long.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void FANN_API fann_get_connection_array(struct fann *ann,'     struct fann_connection *connections);
DECLARE FUNCTION fann_get_connection_array StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL connections AS fann_connection PTR) AS FANN_EXTERNAL ANY FANN_API Ptr 'noptr

' /* Function: fann_set_weight_array' '     Set connections in the network.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' '     Only the weights can be changed, connections and weights are ignored'     if they do not already exist in the network.' '     The array must have sizeof(struct fann_connection) * num_connections size.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void FANN_API fann_set_weight_array(struct fann *ann,'     struct fann_connection *connections, unsigned int num_connections);
DECLARE FUNCTION fann_set_weight_array StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL connections AS fann_connection PTR, _
  BYVAL num_connections AS UINTEGER) AS FANN_EXTERNAL ANY FANN_API Ptr 'noptr

' /* Function: fann_set_weight' '     Set a connection in the network.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' '     Only the weights can be changed. The connection/weight is'     ignored if it does not already exist in the network.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void FANN_API fann_set_weight(struct fann *ann,'     unsigned int from_neuron, unsigned int to_neuron, fann_type weight);
DECLARE FUNCTION fann_set_weight StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL from_neuron AS UINTEGER, _
  BYVAL to_neuron AS UINTEGER, _
  BYVAL weight AS fann_type) AS FANN_EXTERNAL ANY FANN_API Ptr 'noptr

' /* Function: fann_set_user_data' '     Store a pointer to user defined data. The pointer can be'     retrieved with <fann_get_user_data> for example in a'     callback. It is the user's responsibility to allocate and'     deallocate any data that the pointer might point to.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' 		user_data - A void pointer to user defined data.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void FANN_API fann_set_user_data(struct fann *ann, void *user_data);
DECLARE FUNCTION fann_set_user_data StdCall( _
  BYVAL ann AS fann PTR, _
  BYVAL user_data AS ANY PTR) AS FANN_EXTERNAL ANY FANN_API Ptr 'noptr

' /* Function: fann_get_user_data' '     Get a pointer to user defined data that was previously set'     with <fann_set_user_data>. It is the user's responsibility to'     allocate and deallocate any data that the pointer might point to.' '     Parameters:' 		ann - A previously created neural network structure of'             type <struct fann> pointer.' '     Returns:'         A void pointer to user defined data.' '    This function appears in FANN >= 2.1.0' */' FANN_EXTERNAL void * FANN_API fann_get_user_data(struct fann *ann);
DECLARE FUNCTION fann_get_user_data StdCall( _
  BYVAL ann AS fann PTR) AS FANN_EXTERNAL ANY FANN_API PTR

'End Extern 
