'#Include Once "windows.bi"
'#include Once "win/mmsystem.bi"

#Ifndef _PCM_FILE_HDR
enum VCCs
  _RIFF = &H46464952
  _WAVE = &H45564157
  _fmt  = &H20746D66
  _data = &H61746164
end enum

type _PCM_FILE_HDR field = 1
  ChunkRIFF         as integer  ' 4       Chunktype   'RIFF'
  ChunkRIFFSize     as integer  ' 8       ChunkSize
  ChunkID           as integer  '12       ChunkID     'WAVE'
  Chunkfmt          as integer  '16       Chunktype   'fmt '
  ChunkfmtSize      as integer  '20       ChunkSize

    wFormatTag      as short    '22  2
    nChannels       as short    '24  4
    nRate           as integer  '28  8
    nBytesPerSec    as integer  '32 12
    Framesize       as short    '34 14
    nBits           as short    '36 16

  Chunkdata         as integer  '40       Chunktype   'data'
  ChunkdataSize     as integer  '44       ChunkSize
end type
const _PCM_FILE_HDR_SIZE = 44
const _PCM_FMT_SIZE      = 16
#EndIf

Dim  Shared As integer   hOut
Dim  Shared As _PCM_FILE_HDR wavehdr

Dim Shared As Integer wchannels=2,wbits=16,wsamplerate=44100,wnsamples
Const As String ficwave0="wav/mywave.wav"

Sub savewave(ficwave As String,wavdata As UByte Ptr,wavdatasize As Integer, _    
         wbits As Integer=16,wsamplerate As Integer=44100,wchannels As Integer=2)
	         
  hOut=Freefile()
  Open ficwave for binary access write as #hOut

    wavehdr.ChunkDataSize=0
    wavehdr.ChunkRIFF     = _RIFF
    wavehdr.ChunkRIFFSize = sizeof(_PCM_FILE_HDR)-8
    wavehdr.ChunkID       = _WAVE
    wavehdr.Chunkfmt      = _fmt
    wavehdr.ChunkfmtSize  = 16
    wavehdr.wFormatTag    = 1
    wavehdr.nChannels     = wChannels
    wavehdr.nRate         = wsamplerate
    wavehdr.nBytesPerSec  = (wBits\8)*wsamplerate*wChannels
    wavehdr.Framesize     = (wBits\8)*wChannels
    wavehdr.nBits         = wBits
    wavehdr.Chunkdata     = _data
    put #hOut,,wavehdr

  wnsamples=wavdatasize\wavehdr.Framesize
  wavehdr.ChunkRIFFSize+=wnsamples*wavehdr.Framesize
  wavehdr.ChunkdataSize+=wnsamples*wavehdr.Framesize
  put #hOut,,wavdata[0],wnsamples*wavehdr.Framesize


  seek hOut,1
  put #hOut,,wavehdr
  
  Close #hOut
End Sub 
Sub savewave32(ficwave As String,wavdata As UByte Ptr,wavdatasize As Integer, _    
         wbits As Integer=32,wsamplerate As Integer=44100,wchannels As Integer=2)
	         
  hOut=Freefile()
  Open ficwave for binary access write as #hOut

    wavehdr.ChunkDataSize=0
    wavehdr.ChunkRIFF     = _RIFF
    wavehdr.ChunkRIFFSize = sizeof(_PCM_FILE_HDR)-8
    wavehdr.ChunkID       = _WAVE
    wavehdr.Chunkfmt      = _fmt
    wavehdr.ChunkfmtSize  = 16
    wavehdr.wFormatTag    = 3 'WAVE_FORMAT_IEEE_FLOAT
    wavehdr.nChannels     = wChannels
    wavehdr.nRate         = wsamplerate
    wavehdr.nBytesPerSec  = (wBits\8)*wsamplerate*wChannels
    wavehdr.Framesize     = (wBits\8)*wChannels
    wavehdr.nBits         = wBits
    wavehdr.Chunkdata     = _data
    put #hOut,,wavehdr

  wnsamples=wavdatasize\wavehdr.Framesize
  wavehdr.ChunkRIFFSize+=wnsamples*wavehdr.Framesize
  wavehdr.ChunkdataSize+=wnsamples*wavehdr.Framesize
  put #hOut,,wavdata[0],wnsamples*wavehdr.Framesize


  seek hOut,1
  put #hOut,,wavehdr
  
  Close #hOut
End Sub 
