#include once "crt/string.bi" 'for memcpy


private _
function _LoadWave_short(byval Filepcm        as ubyte ptr, _
                   byval nRateTarget     as integer , _
                   byval nBitsTarget     as integer , _
                   byval nChannelsTarget as integer , _
                   byval lpnBytes        as integer ptr) as any ptr

  dim as _PCM_FILE_HDR hdr
  dim as integer   hFile,SeekPos,nBytesTarget,nSamples,nSamplesTarget,i,oPos,cPos
  dim as single    l,r
  dim as double    Scale,nPos
  dim as ubyte     v8
  dim as short     v16
  dim as short ptr p16
  dim as ubyte ptr file
  dim as integer filepos=0

  oPos=-1
  'if GetWaveInfo(Filename,hdr,@SeekPos)=true then
  memcpy(@hdr,filepcm+8,sizeof(_PCM_FILE_HDR))
    nSamples=hdr.Chunkdatasize \ hdr.Framesize
    Scale=hdr.nRate/nRateTarget
    nSamplesTarget=nSamples*(1.0/Scale)
    nBytesTarget=nSamplesTarget*(nBitsTarget\8)*nChannelsTarget
    'hFile=Freefile()
    'if open(FileName for binary access read as #hFile)=0 then
      'seek #hFile,SeekPos
      p16=callocate(nBytesTarget)
      'file=callocate(lof(hfile)-seekpos+1)
      if p16=NULL then 'or file=NULL then
        close #hFile
        deallocate(p16)
        'deallocate(file)
        return NULL
      end if
      'get #hFile,,*file,(lof(hfile)-seekpos+1)
      file=filepcm+8+sizeof(_PCM_FILE_HDR)

      if nSamples<=nSamplesTarget then
        for i=0 to nSamplesTarget-1
          ' jump over in source
          if oPos<>cPos then
            ' read samples l,r -0.5 - 0.5
            if hdr.nBits=8 then
              'read ubyte 0<->255
              'get #hFile,,v8
              v8=file[filepos]:filepos+=1
              ' convert to -128.0 <-> +127.0
              l=csng(v8):l-=128
              ' convert to -0.5 <-> +0.5
              l*=(0.5f/128.0f)
              if hdr.nChannels=2 then
                'get #hFile,,v8
                v8=file[filepos]:filepos+=1
                r=csng(v8):r-=128
                ' convert to -0.5 <-> +0.5
                r*=(0.5f/128.0f)
              else
                r=l
              end if
            else
              'get #hFile,,v16
              v16=cshort(file[filepos]+file[filepos+1]*256):filepos+=2
              l=(0.5f/32767.0f)*v16
              if hdr.nChannels=2 then
                'get #hFile,,v16
                v16=cshort(file[filepos]+file[filepos+1]*256):filepos+=2
                r=(0.5f/32767.0f)*v16
              else
                r=l
              end if
            end if
            oPos=cPos
          end if
          ' write every in target
          if nChannelsTarget=1 then
            p16[i    ]=cshort(l*16383f + r*16383f)
          else
            p16[i*2  ]=cshort(l*32767.0f)
            p16[i*2+1]=cshort(r*32767.0f)
          end if
          nPos+=scale:cPos=int(nPos)
          ' don't read more than len(source)
          if cPos>=nSamples then exit for
        next
      else ' read every source Sample
        scale=(1.0/scale)
        for i=0 to nSamples-1
          ' read samples l,r -0.5 - +0.5
          if hdr.nBits=8 then
            'read ubyte 0<->255
            'get #hFile,,v8
            v8=file[filepos]:filepos+=1
            ' convert to -128.0 <-> +127.0
            l=csng(v8):l-=128
            ' convert to -0.5 <-> +0.5
            l*=(0.5f/128.0f)
            if hdr.nChannels=2 then
              'get #hFile,,v8
              v8=file[filepos]:filepos+=1
              r=csng(v8):r-=128
              ' convert to -0.5 <-> +0.5
              r*=(0.5f/128.0f)
            else
              r=l
            end if
          else
            'get #hFile,,v16
            v16=cshort(file[filepos]+file[filepos+1]*256):filepos+=2
            l=(0.5f/32767.0f)*v16
            if hdr.nChannels=2 then
              'get #hFile,,v16
              v16=cshort(file[filepos]+file[filepos+1]*256):filepos+=2
              r=(0.5f/32767.0f)*v16
            else
              r=l
            end if
          end if
          ' jump over in destination
          if oPos<>cPos then
            if nChannelsTarget=1 then
              p16[cPos    ]=cshort(l*16383.5f + r*16383.5f)
            else
              p16[cPos*2  ]=cshort(l*32767.0f)
              p16[cPos*2+1]=cshort(r*32767.0f)
            end if
            oPos=cPos
          end if
          nPos+=scale:cPos=int(nPos)
          ' don't write more than len(target)
          if cPos>=(nSamplesTarget-1) then exit for
        next
      end if
      close #hFile
      *lpnBytes=nBytesTarget
      'deallocate(file)
      return p16
    'end if ' open=0
  'end if ' GetWaveInfo<>0
  return NULL
end function


public _
function FBS_Load_WAVFile_short(byval Filepcm as ubyte ptr, _
                          byval hWave    as integer ptr) as fbsboolean export
  dim as any ptr _new
  dim as integer nBytes,flag,i
  if hWave  =NULL  then return false
  if _IsInit=false then *hWave=-1:return false

  _new=_LoadWave_short(Filepcm, _
                _Plugs(_Plug).Fmt.nRate    , _
                _Plugs(_Plug).Fmt.nBits    , _
                _Plugs(_Plug).Fmt.nChannels, _
                @nBytes)

  if _new=NULL then
    *hWave=-1
    return false
  end if
  ' new sound
  if _nWaves=0 then
    redim _Waves(_nWaves)
    _Waves(_nWaves).lpStart= _new
    _Waves(_nWaves).nBytes=nBytes
    *hWave=_nWaves
    _nWaves+=1
  else
    flag=-1
    for i=0 to _nWaves-1
      if _Waves(i).lpStart=NULL then flag=i:exit for
    next

    if flag>-1 then
      _Waves(flag).lpStart= _new
      _Waves(flag).nBytes=nBytes
      *hWave=flag
    else
      redim preserve _Waves(_nWaves)
      _Waves(_nWaves).lpStart= _new
      _Waves(_nWaves).nBytes=nBytes
      *hWave=_nWaves
      _nWaves+=1
    end if
  end if
   return true
end function



private _
function outputcallback_short cdecl (byval lpData   as any ptr             , _
                          byval lpHeader as mad_header PTR, _
                          byval lpPCM    as mad_pcm    PTR) as integer
  dim as MP3_BUFFER PTR buf=cptr(MP3_BUFFER PTR,lpData)
  dim as integer i
  dim as uinteger ptr houtindex=cast(uinteger ptr,buf->hOut)
  dim as uinteger iaux

  if lpPCM->channels>1 then
      _ScaleMP3FrameStereo(buf->lpFileBuf, _
                           @lpPCM->samples(0,0), _
                           @lpPCM->samples(1,0), _, _
                           lpPCM->length)
  else
    _ScaleMP3FrameMono(buf->lpFileBuf, _
                      @lpPCM->samples(0,0), _
                       lpPCM->length)
  end if

  ' first time write wave header
  if buf->wavehdr.ChunkDataSize=0 then
    buf->wavehdr.ChunkRIFF     = _RIFF
    buf->wavehdr.ChunkRIFFSize = sizeof(_PCM_FILE_HDR)-8
    buf->wavehdr.ChunkID       = _WAVE
    buf->wavehdr.Chunkfmt      = _fmt
    buf->wavehdr.ChunkfmtSize  = 16
    buf->wavehdr.wFormatTag    = 1
    buf->wavehdr.nChannels     = _Plugs(_Plug).fmt.nChannels
    buf->wavehdr.nRate         = lpPCM->samplerate
    buf->wavehdr.nBytesPerSec  = (_Plugs(_Plug).fmt.nBits\8)*lpPCM->samplerate*_Plugs(_Plug).fmt.nChannels
    buf->wavehdr.Framesize     = (_Plugs(_Plug).fmt.nBits\8)*_Plugs(_Plug).fmt.nChannels
    buf->wavehdr.nBits         =_Plugs(_Plug).fmt.nBits
    buf->wavehdr.Chunkdata     = _data
    'put #buf->hOut,,buf->wavehdr
    memcpy(cast(ubyte ptr,buf->hOut+8),@(buf->wavehdr),sizeof(buf->wavehdr))
    houtindex[0]=buf->hout+8+sizeof(buf->wavehdr)
  end if

  'buf->wavehdr.ChunkRIFFSize+=lpPCM->length*buf->wavehdr.Framesize
  'buf->wavehdr.ChunkdataSize+=lpPCM->length*buf->wavehdr.Framesize
  'put #buf->hOut,,buf->lpFileBuf[0],lpPCM->length*buf->wavehdr.Framesize
  iaux=lpPCM->length*buf->wavehdr.Framesize
  if (houtindex[0]+iaux)<houtindex[1] then
     memcpy(cast(ubyte ptr,houtindex[0]),@(buf->lpFileBuf[0]),iaux)
     houtindex[0]+=iaux
     buf->wavehdr.ChunkRIFFSize+=iaux
     buf->wavehdr.ChunkdataSize+=iaux
  else
     houtindex[0]=houtindex[1]
  endif
return MAD_FLOW_CONTINUE
end function


private _
function _DecodeMP3_short(byval lpStart   as any ptr, _
                byval Size      as integer, _
                byval hOut      as integer) as integer

  dim as MP3_BUFFER  buf
  dim as mad_decoder decoder
  dim as integer     result

  ' initialize our private message structure
  buf.Start    = lpStart
  buf.Size     = Size
  buf.hOut     = hOut
  buf.lpFileBuf=allocate(sizeof(short)*1152*2*4)

  ' configure input, output, and error _FUs
  mad_decoder_init(@decoder        , _
                   @buf            , _
                   @inputcallback  , _
                   0               , _ ' header
                   0               , _ ' filter
                   @outputcallback_short , _
                   @errorcallback  , _
                   0)                  ' message

  ' start decoding
  result = mad_decoder_run(@decoder, MAD_DECODER_MODE_SYNC)
  'seek buf.hOut,1
  'put #buf.hOut,,buf.wavehdr
  memcpy(cast(ubyte ptr,hout+8),@(buf.wavehdr),sizeof(buf.wavehdr))
  ' release the decoder
  mad_decoder_finish(@decoder)
  if buf.lpFileBuf<>NULL then deallocate buf.lpFileBuf
  return result
end function


public _
function FBS_Load_MP3File_short(byval Filename as string , _  'for files < 60s 16bits 44.1Khz (wav<12Mo)
                          byval lphWave  as integer ptr  , _
                          byval maxsize as integer=12000000, _
                          byval debug as integer=0) as fbsboolean export
  dim as ubyte ptr file
  dim as byte ptr lpMP3
  dim as integer hFile,hOut,size,ret
  dim as string  infile ',outtmp

  if lphWave=NULL then return false
  *lphWave=-1
  if _IsInit=false then return false

  infile=FileName

  hFile=Freefile
  if open(infile for binary access read as #hFile)<>0 then return false
  size=lof(hFile)
  if size = 0 then close #hfile:return false
  lpMP3 = callocate(size)
  if lpMP3 = NULL then close #hfile:return false

  get #hFile,,*lpMP3,size

  dim as uinteger maxfilesize=maxsize
  'if maxfilesize>(size*20) then maxfilesize=size*20
  if maxfilesize>100000000 then maxfilesize=100000000 'max 100M
  if maxfilesize<100000 then maxfilesize=100000       'min 100K
  file=callocate(maxfilesize)
  '?"mp3short alloc filepcm="+str(maxfilesize)+"  "+infile

  hOut=cast(uinteger,file)
  if file=NULL then
    if (lpMP3<>NULL) then  deallocate lpMP3:lpMP3=NULL
    return false
  end if
  dim as uinteger ptr houtindex=cast(uinteger ptr,hout)
  houtindex[0]=hout+8
  houtindex[1]=hout+maxfilesize

  ret=_DecodeMP3_short(lpMP3,size,hOut)
  'close #hOut
  close #hFile
  if (lpMP3<>NULL) then deallocate lpMP3:lpMP3=NULL
  if debug<>0 then ?"mp3short wav size="+str(houtindex[0]-hout)+"  "+infile
  if houtindex[0]>=houtindex[1] then ?"warning mp3 file truncated :"+infile

  if ret=0 then
    if FBS_Load_WAVFile_short(file,lphWave)=true then
       deallocate file:file=NULL
       return true
    else
      deallocate file:file=NULL
      *lphWave=-1
      return false
    end if
  else
    deallocate file:file=NULL
    *lphWave=-1
    return false
  end if
end function


